package api;

import model.RouteInformation;
import java.awt.BorderLayout;
import java.awt.HeadlessException;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Platform;
import javafx.embed.swing.JFXPanel;
import javafx.scene.Scene;
import javafx.scene.web.WebEngine;
import javafx.scene.web.WebView;
import javax.swing.JFrame;
import netscape.javascript.JSObject;

/**
 *
 * @author Hnedle
 */
public class Browser extends JFrame {

    JFXPanel panel = new JFXPanel();
    Scene scene;
    WebView view;
    WebEngine engine;

    RouteInformation info;
//------------------------------------------------------------------------------
    public Browser() throws HeadlessException {
    }

    private void start() throws FileNotFoundException, IOException {
        view = new WebView();
        engine = view.getEngine();
        String mapa = GoogleMap();
        engine.loadContent(mapa);
        //engine.load( "http://www.seznam.cz");
        add(panel, BorderLayout.CENTER);
        engine.setJavaScriptEnabled(true);

        scene = new Scene(view);
        panel.setScene(scene);
        JSObject jsobj = (JSObject) engine.executeScript("window");
        jsobj.setMember("java", this);

        pack();

        setVisible(true);

    }

    private String GoogleMap() throws FileNotFoundException, IOException {
        InputStream is = this.getClass().getResourceAsStream("/bakalarka/googlemap.html");
        String mapa = convertStreamToString(is);
        is.close();

        mapa = mapa.replace("adresa1", info.getAdresa1());
        mapa = mapa.replace("adresa2", info.getAdresa2());
        mapa = mapa.replace("way1", info.getWayPoints());
        mapa = mapa.replace("Highways1", info.getHighways());
        mapa = mapa.replace("Tolls1", info.getTolls());
        mapa = mapa.replace("optimizeWaypoints1", info.getOptimizeWaypoints());

        return mapa;

    }

    private static String convertStreamToString(java.io.InputStream is) {
        java.util.Scanner s = new java.util.Scanner(is).useDelimiter("\\A");
        return s.hasNext() ? s.next() : "";
    }

    public void setVzdalenost(Object vyslednaVzdalenost) {

        Object vysledek = vyslednaVzdalenost;
        int vzdalenost = Integer.valueOf(vysledek.toString());
        info.getVzdalenost().setText(Integer.valueOf(vysledek.toString()) + " Km");

    }

    public void setPruAdresy(Object seznamAdres) {
        String adresy = (String) seznamAdres;
        String[] tokens = adresy.split(";");
        for (int i = 0; i < tokens.length; i++) {
            tokens[i] = tokens[i].replace(", Czech Republic", "");
        }
        info.refreshAdressy(tokens);
    }

    public void setMyTime(Object myTime) {
        System.out.println("funguji");
        String a = (String) myTime;

        Double d = Double.valueOf(a);
        int c = (int) (d / 60);

        a = c + " min.";

        System.out.println(a);

        info.setMyTime(a);

    }

    public void zobrazit(RouteInformation info) {
        this.info = info;

        Platform.runLater(new Runnable() {

            @Override
            public void run() {
                try {
                    start();
                } catch (IOException ex) {
                    Logger.getLogger(Browser.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });

    }

}
