package api;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import model.RouteData;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Iterator;
import javax.swing.JOptionPane;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

public class RouteParser {

    SAXReader reader = new SAXReader();
   
    String dobaJizdy;
    Integer vzdalenost;
    Document document;
    String originAddress;
    String destinationAddress;
    RouteData data;
//------------------------------------------------------------------------------
    public RouteParser(){
       
    }

    
    public RouteData parse(String adresa1, String adresa2, ArrayList<String> wayPoints) throws MalformedURLException, DocumentException, UnsupportedEncodingException, TransformerConfigurationException, TransformerException, IOException {
        String wayPoin = "";
        for (int i = 0; i < wayPoints.size(); i++) {
            wayPoin = wayPoin + URLEncoder.encode(wayPoints.get(i), "UTF-8") + "|";
        }

        //   String url2 = "http://maps.googleapis.com/maps/api/distancematrix/xml?origins=" + URLEncoder.encode(adresa1, "UTF-8") + "&destinations=" + URLEncoder.encode(adresa2, "UTF-8") + "&mode=driving&sensor=false&";                
        String url = "https://maps.googleapis.com/maps/api/directions/xml?origin=" + URLEncoder.encode(adresa1, "UTF-8") + "&destination=" + URLEncoder.encode(adresa2, "UTF-8") + "&waypoints=" + wayPoin + "&language=cs";

        System.out.println(url);

        data = new RouteData();
        data.setAdresa1(adresa1);
        data.setAdresa2(adresa2);
        data.setVzdalenost(new Integer(0));
        try {
            document = reader.read(new URL(url));
           
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Adresa nenalezena");
            return data;
        }
        

        String status = document.getRootElement().element("status").getText();
        System.out.println(status);
       
        //top status
        if (status.equals("REQUEST_DENIED")) {

            JOptionPane.showMessageDialog(null, "Adresa nenalezena");

            return data;
        }

        if (status.equals("INVALID_REQUEST")) {

            JOptionPane.showMessageDialog(null, "Špatně zadaná adresa");

            return data;
        }
        //element status
        if (status.equals("ZERO_RESULTS")) {

            JOptionPane.showMessageDialog(null, "Trasa nenalezena");

            return data;
        }
        if (status.equals("NOT_FOUND")) {

            JOptionPane.showMessageDialog(null, "Adresa nenalezena");

            return data;
        }
        if (status.equals("OK")) {
       

            Element root = document.getRootElement().element("route");

            double pomVzdalenost = 0;
            double pomCas = 0;
            Iterator i = root.elementIterator("leg");
            ArrayList<String> way = new ArrayList<>();

            while (i.hasNext()) {

                Element distance = (Element) i.next();
                String a = distance.element("distance").element("value").getText();
                pomVzdalenost = pomVzdalenost + Double.valueOf(a);

                way.add(distance.element("start_address").getText());
                
                a = distance.element("duration").element("value").getText();
                pomCas = pomCas + Double.valueOf(a);
                
                
                if (!i.hasNext()) {
                    
                    way.add(distance.element("end_address").getText().replace(", Czech Republic", ""));
                }
            }
            vzdalenost = (int) (pomVzdalenost / 1000);
            dobaJizdy = (pomCas/60) + " min.";

            originAddress = way.get(0);
            
            
            destinationAddress = way.get(way.size()-1);
            System.out.println(destinationAddress);
            data.setAdresa1(originAddress.replace(", Czech Republic", ""));
            //  destinationAddress = document.getRootElement().element("destination_address").getText();
            data.setAdresa2(destinationAddress.replace(", Czech Republic", ""));
            data.setVzdalenost(vzdalenost);
            data.setDobaJizdy(dobaJizdy);
            way.remove(0);
            way.remove(way.size()-1);
            data.setAdresy(way);
        }
        return data;
    }

}
